-- 瘋狂砸蛋
checkRequire("Lua_CrazyEggsItem");
checkRequire("Lua_CrazyEggsExtraRewardItem");
checkRequire("Lua_CrazyEggsRecordItem");
Lua_CrazyEggsWindow  = class("Lua_CrazyEggsWindow", Lua_ActivityBaseWindow);
function Lua_CrazyEggsWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_CrazyEggsWindow";
	self.skinName = "CrazyEggsWindow_skin";
	self.fenGeXian = false;
	self.showBgBack = false;
end

function Lua_CrazyEggsWindow:buildShowItem()
	self:superCall("buildShowItem");

	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.CRAZY_EGGS);

	local posList = {{-435, 21},{-330, 21},{-225, 21},{-120, 21},{-15, 21},{-435, -72},{-330, -72},{-225, -72},{-120, -72},{-15, -72}};
	local item;
	self.eggArr = Array();
	for i,v in ipairs(posList) do
		item = Lua_CrazyEggsItem.new(self.content);
		item.name = i;
		item:setDepth(5);
		item:setLocation(v[1], v[2], 0);
		self.eggArr:add(item);
	end

	self.goldList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 250, 65));
	self.goldList:setLocation(-352, 138, 0);
	self.goldList:setListCell(Lua_CrazyEggsPoolItem, 65, 55, 9999);

	self.colorList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 250, 65));
	self.colorList:setLocation(-63, 138, 0);
	self.colorList:setListCell(Lua_CrazyEggsPoolItem, 65, 55, 9999);

	self.rewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 380, 254));
	self.rewardList:setLocation(280, -121, 0);
	self.rewardList:setListCell(Lua_CrazyEggsExtraRewardItem, 130, 372, 1);

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(272, -75, 350, 155));
	self.dragContainer:setLocation(5, 166, 0);
	self.dragContainer.uiPanel.depth = 3000;

	self.btnClose:setLocation(466, 232);
	self.free_redDot:setEnable(false);
	self.free_time:setEnable(false);
	self.smashBtn.label = LanUtil.getValue(144605);
	self.refreshBtn:addClickFuntion(self, self.onRefreshBtnClick);
	self.smashBtn:addClickFuntion(self, self.onSmashBtnClick);
	self.helpBtn:addClickFuntion(self, self.onHelpBtnClick);

	self:addLuaEvent("UPDATE_CRAZY_EGGS", self, self.updatePanelInfo);
end

function Lua_CrazyEggsWindow:dispose()
	if self.eggArr ~= nil then
		self.eggArr:dispose();
		self.eggArr = nil;
	end
	if self.goldList ~= nil then
		self.goldList:dispose();
		self.goldList = nil;
	end
	if self.colorList ~= nil then
		self.colorList:dispose();
		self.colorList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	Lua_CommonUtil.removeTimer(self, self.updateFreeTime);
	Lua_CommonUtil.removeTimer(self, self.smashAllTimeDown);
	DataCenter.crazyEggsData.isSmashAll = false;
	DataCenter.crazyEggsData.isSmashOne = false;
	DataCenter.crazyEggsData:resetEggSmashSelect();

	self:superCall("dispose");
end

function Lua_CrazyEggsWindow:updatePanelInfo()
	DataCenter.crazyEggsData:checkRedDot();

	local arr = DataCenter.crazyEggsData.getEggsList;
	for i = 1, arr:getSize() do
		self.eggArr[i]:setData(arr[i]);
	end
	
	self.useMoney_1.text = LanUtil.formateStr(LanUtil.getValue(144601), tostring(DataCenter.crazyEggsData.gold_fresh));
	self.useMoney_2.text = DataCenter.crazyEggsData.totalSmashCost;

	Lua_CommonUtil.addTimer("CrazyEggs_ResidueTimer", 1, self, self.updateResidueTime, nil, -1);
	self:updateResidueTime();

	self.goldList:setLuaArrayData(DataCenter.crazyEggsData.getGoldPool, false);
	self.colorList:setLuaArrayData(DataCenter.crazyEggsData.getColorPool, false);
	self.rewardList:setLuaArrayData(DataCenter.crazyEggsData.getExtraRewardData, false);

	local arr = DataCenter.crazyEggsData.getRecordData;
	self.dragContainer:removeAllChildren();
	for i=1,arr:getSize() do
		item = Lua_CrazyEggsRecordItem.new(self.dragContainer.sub);
		self.dragContainer:addSubContainer(item, false);
		self.dragContainer.childrenList[i]:setData(arr[i]);
	end
	self.dragContainer:updateChildPos();
	self.dragContainer:moveToChildIndex(1, true);

	self:checkFree();
end

function Lua_CrazyEggsWindow:checkFree()
	if DataCenter.crazyEggsData.free_open == 0 then -- 关闭免费刷新
		self.free_time:setEnable(false);
		self.free_redDot:setEnable(false);
		self.refreshBtn.label = LanUtil.getValue(144604);

		if self.bStartTime ~= nil and self.bStartTime == true then
			self.bStartTime = false;
			Lua_CommonUtil.removeTimer(self, self.updateFreeTime);
		end
	else
		if DataCenter.crazyEggsData.free_fresh == 1 then -- 有免费次数
			self.free_time:setEnable(false);
			self.free_redDot:setEnable(true);
			self.refreshBtn.label = LanUtil.getValue(144603);

			if self.bStartTime ~= nil and self.bStartTime == true then
				self.bStartTime = false;
				Lua_CommonUtil.removeTimer(self, self.updateFreeTime);
			end
		else
			self.free_redDot:setEnable(false);
			self.refreshBtn.label = LanUtil.getValue(144604);
			if DataCenter.crazyEggsData.freeTime > 0 then -- 有剩余免费次数倒计时
				self:updateFreeTime();
				if self.bStartTime == nil or self.bStartTime == false then
					self.bStartTime = true;
					Lua_CommonUtil.addTimer("CrazyEggs_FreeTimer", 1, self, self.updateFreeTime, nil, -1);
				end
			else
				self.free_time:setEnable(false);
				if self.bStartTime ~= nil and self.bStartTime == true then
					self.bStartTime = false;
					Lua_CommonUtil.removeTimer(self, self.updateFreeTime);
				end
			end
		end
	end
end

-- 活动剩余时间
function Lua_CrazyEggsWindow:updateResidueTime()
	local left_time = tonumber(DataCenter.crazyEggsData.end_tick) - DataCenter.roleData.serverTime;
	if left_time > 0 then
		self.left_time.text = LanUtil.formateStr(LanUtil.getValue(144600), TimeTransform.getInstance():transSeconds1(left_time, true));
	else
		self.left_time.text = LanUtil.getValue(144610);
		Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	end
end

-- 更新免费刷新时间
function Lua_CrazyEggsWindow:updateFreeTime()
	local free_time = DataCenter.crazyEggsData.freeTime;
	if free_time > 0 then
		self.free_time:setEnable(true);
		self.free_time.text = LanUtil.formateStr(LanUtil.getValue(144602), TimeTransform.getInstance():transSeconds1(free_time, true));
	else
		self.free_time:setEnable(false);
		if self.bStartTime ~= nil and self.bStartTime == true then
			self.bStartTime = false;
			Lua_CommonUtil.removeTimer(self, self.updateFreeTime);
		end
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.CRAZY_EGGS);
	end
end

function Lua_CrazyEggsWindow:onHelpBtnClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, DataCenter.crazyEggsData.content);
end

function Lua_CrazyEggsWindow:onRefreshBtnClick()
	if DataCenter.crazyEggsData.isSmashAll or DataCenter.crazyEggsData.isSmashOne then
		OperateAlert.show(LanUtil.getValue(144619));
		return;
	end

	if DataCenter.crazyEggsData.free_open == 0 then
		self:checkRefreshCost();
	else
		if DataCenter.crazyEggsData.free_fresh == 1 then -- 有免费次数
			Lua_ProxyManager.getProxy("Lua_CrazyEggsProxy"):sRefreshCrazyEggs(1);
		else
			self:checkRefreshCost();
		end
	end
end

function Lua_CrazyEggsWindow:onSmashBtnClick()
	if DataCenter.crazyEggsData.isSmashAll or DataCenter.crazyEggsData.isSmashOne then
		OperateAlert.show(LanUtil.getValue(144619));
		return;
	end

	if DataCenter.crazyEggsData:checkIsAllSmash() then
		OperateAlert.show(LanUtil.getValue(144617));
		return;
	end

	local totalSmashCost = DataCenter.crazyEggsData.totalSmashCost;
	local str;
	if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < totalSmashCost then
		str = "["..Lua_ColorDefine.RED_STR.."]"..totalSmashCost.."[-]";
		self.enoughAllSmash = false;
	else
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..totalSmashCost.."[-]";
		self.enoughAllSmash = true;
	end

	local noOpenEggsCount = 0;
	local allEggsArr = DataCenter.crazyEggsData.getEggsList;
	for i = 1, allEggsArr:getSize() do
		if allEggsArr[i].open == 0 then
			noOpenEggsCount = noOpenEggsCount + 1;
		end
	end

	local backInfo = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if noOpenEggsCount > backInfo:getLeftSize() then
		OperateAlert.show(LanUtil.getValue(110863));
		return;
	end

	if DataCenter.neverTip:getNeverValue("SmashAllCost") == true then
		if self.enoughAllSmash == false then
			DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, totalSmashCost, true, true);
		else
			DataCenter.crazyEggsData.isSmashAll = true;
			for i = 1, self.eggArr:getSize() do
				self.eggArr[i]:playEffect();
			end
			self.playTime = 2;
			Lua_CommonUtil.addTimer("SmashAllTimeDown", 1, self, self.smashAllTimeDown);
		end
		return;
	end

	local totalGoldEgg = DataCenter.crazyEggsData.totalGoldEgg;
	local totalColorEgg = DataCenter.crazyEggsData.totalColorEgg;
	local des;
	if totalColorEgg == 0 then
		des = LanUtil.formateStr(LanUtil.getValue(144613), str, LanUtil.getValue(144615), tostring(totalGoldEgg));
	elseif totalGoldEgg == 0 then
		des = LanUtil.formateStr(LanUtil.getValue(144613), str, LanUtil.getValue(144616), tostring(totalColorEgg));
	else
		des = LanUtil.formateStr(LanUtil.getValue(144614), str, LanUtil.getValue(144616), tostring(totalColorEgg), LanUtil.getValue(144615), tostring(totalGoldEgg));
	end

	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
		owner = self,
		neverTip = "SmashAllCost",
		des = des,
		type = 1,
		subFun = self.onSmashAllSureFun
	});
end

function Lua_CrazyEggsWindow:onSmashAllSureFun()
	if self.enoughAllSmash == false then
		DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, DataCenter.crazyEggsData.totalSmashCost, true, true);
	else
		DataCenter.crazyEggsData.isSmashAll = true;
		for i = 1, self.eggArr:getSize() do
			self.eggArr[i]:playEffect();
		end
		self.playTime = 2;
		Lua_CommonUtil.addTimer("SmashAllTimeDown", 1, self, self.smashAllTimeDown);
	end
end

function Lua_CrazyEggsWindow:smashAllTimeDown()
	self.playTime = self.playTime - 1;
	if self.playTime <= 0 then
		if DataCenter.crazyEggsData.isSmashAll then
			DataCenter.crazyEggsData.isSmashAll = false;
			local arr = DataCenter.crazyEggsData.getEggsList;
			for i = 1, arr:getSize() do
				if self.eggArr[i].effectEgg ~= nil then
					self.eggArr[i].effectEgg:dispose();
					self.eggArr[i].effectEgg = nil;
				end
			end
			Lua_ProxyManager.getProxy("Lua_CrazyEggsProxy"):sSmashAllEggs();
		end
		Lua_CommonUtil.removeTimer(self, self.smashAllTimeDown);
	end
end

function Lua_CrazyEggsWindow:checkRefreshCost()
	local gold_fresh = DataCenter.crazyEggsData.gold_fresh;
	local str;
	if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < gold_fresh then
		str = "["..Lua_ColorDefine.RED_STR.."]"..gold_fresh.."[-]";
		self.enoughRefresh = false;
	else
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..gold_fresh.."[-]";
		self.enoughRefresh = true;
	end

	if DataCenter.neverTip:getNeverValue("RefreshCost") == true then
		if self.enoughRefresh == false then
			DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, gold_fresh, true, true);
		else
			Lua_ProxyManager.getProxy("Lua_CrazyEggsProxy"):sRefreshCrazyEggs(2);
		end
		return;
	end

	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
		owner = self,
		neverTip = "RefreshCost",
		des = LanUtil.formateStr(LanUtil.getValue(144611), str),
		type = 1,
		subFun = self.onRefreshSureFun
	});
end

function Lua_CrazyEggsWindow:onRefreshSureFun()
	if self.enoughRefresh == false then
		DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, DataCenter.crazyEggsData.gold_fresh, true, true);
	else
		Lua_ProxyManager.getProxy("Lua_CrazyEggsProxy"):sRefreshCrazyEggs(2);
	end
end





--------------------------------------------------





Lua_CrazyEggsPoolItem = class("Lua_CrazyEggsPoolItem", Lua_ListCell);
function Lua_CrazyEggsPoolItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rItem = Lua_ToolImage.new(self.content);
	self.rItem:setDepth(5);
	self.rItem:setCanClick(false);
	self.rItem:setLocation(0, 0, 0);
	self.rItem:setScale(0.65, 0.65);
end

function Lua_CrazyEggsPoolItem:setData(data)
	self.data = data;

	self.rItem.data = data.vo;
	self.rItem:showMaskSp(false);
	self.rItem:showNotYetImg(false);

	if data.show_effect == 1 then
		self.rItem:showRoundEff(true);
		if roundEff ~= nil then
			self.rItem.roundEff:SetRenderQueue(self.rItem.item_bg, 5, 2, true);
		end
	end
end 

function Lua_CrazyEggsPoolItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data.vo);
	end
end

function Lua_CrazyEggsPoolItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX - 25, self.itemY, 50, 30);
	if self.rItem.roundEff ~= nil then
		if showRect:containeRect(rect) == true then
			self.rItem.roundEff:setEnable(true);
		else
			self.rItem.roundEff:setEnable(false);
		end
	end

	if self.rItem.data.subType == Lua_PackTypeDefine.STAMP_ITEM then
		if self.rItem.stampEff ~= nil then
			if showRect:containeRect(rect) == true then
				self.rItem.stampEff:setEnable(true);
			else
				self.rItem.stampEff:setEnable(false);
			end
		end
	end
	
	if self.rItem.data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then
		if self.rItem.armyEff ~= nil then
			if showRect:containeRect(rect) == true then
				self.rItem.armyEff:setEnable(true);
			else
				self.rItem.armyEff:setEnable(false);
			end
		end
	end
end